#include <cstdlib>
#include <fstream>
#include <iostream>
#include <limits>
#include <cmath>

using namespace std;

int vector[10000];
int diff[10000];

int result[10000][10000/3];

int n;

void sort() {
	int j, temp;
	for (int i=1; i < n; i++) {
		j = i;
		while (j > 0 && vector[j] < vector[j-1]) {
			temp = vector[j-1];
			vector[j-1] = vector[j];
			vector[j] = temp;
			j--; 
		}
	}
}


int findMin(int i, int t) {
	if (i >= n)
		return 100000;
	if (t == 0)
		return diff[i];
	if (result[i][t] != -1)
		return result[i][t];

	int a = diff[i] + findMin(i+2, t - 1);
	int b = findMin(i+1, t);
	result[i][t] = a < b ? a : b;
	return result[i][t];
}

int main(int argc, char** argv) {

	ifstream fin("input.txt");
	fin >> n;
	
	for (int i=0; i < n; i++)
		fin >> vector[i];
	fin.close();

	sort();

	for (int i=0; i < n-1; i++)
			diff[i] = abs(vector[i] - vector[i+1]);

	for (int i=0; i < n; i++) {
		for (int j=0; j <= n/3; j++)
			result[i][j] = -1;
	}

	int min = findMin(0, n/3);

	/*cout << min << endl;
	for(int i=0; i< n; i++) {
		for (int j=0; j< n/3; j++)
			cout << result[i][j] << "\t";
		cout << endl;
	}*/

	ofstream fout("output.txt");
	fout << min;
	fout.close();
}
